Subject: bug#30964: python-mode failing "overlapping strings" assertion lately

From: "Daniel Colascione" <[email-masked]>
Date: Sat, 16 Jun 2018 13:55:49 -0700

So it turns out that it wasn't an off-by-one problem at all.  Instead,
python was using (re-search-forward (rx (syntax string-delimiter))), which
was matching incorrectly because re-search-forward didn't update syntax as
it matched. It didn't do that because regex matching in general wasn't
reentrant, and it wasn't reentrant because regex bytecode programs are
self-modifying.

I checked in some work that makes regex searching update syntax as needed.